Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/IImageKeys.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/IImageKeys.java	(revision 3060)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/IImageKeys.java	(revision 3061)
@@ -88,6 +88,9 @@
 	/** The Constant ACTION_SEARCH. */
 	public static final String ACTION_SEARCH = "icons/functions/Search.png"; //$NON-NLS-1$
 	
+	/** The Constant ACTION_SEARCH. */
+	public static final String ACTION_SEARCH_SETTINGS = "icons/functions/Search_settings.png"; //$NON-NLS-1$
+	
 	/** The Constant ACTION_CAH. */
 	public static final String ACTION_CAH = "icons/functions/CAH.png"; //$NON-NLS-1$
 	
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/TokenizerSection.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/TokenizerSection.java	(revision 3060)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/TokenizerSection.java	(revision 3061)
@@ -124,7 +124,7 @@
 		gdata.indent = 20;
 		l1.setLayoutData(gdata);
 		
-		textWhiteSpaces = toolkit.createText(sectionClient, TokenizerClasses.whitespaces, SWT.BORDER);
+		textWhiteSpaces = toolkit.createText(sectionClient, "", SWT.BORDER);
 		gdata = getLongTextGridData();
 		textWhiteSpaces.setLayoutData(gdata);
 		
@@ -134,7 +134,7 @@
 		gdata.indent = 20;
 		l2.setLayoutData(gdata);
 		
-		textPuncts = toolkit.createText(sectionClient, TokenizerClasses.regPunct, SWT.BORDER);
+		textPuncts = toolkit.createText(sectionClient, "", SWT.BORDER);
 		gdata = getLongTextGridData();
 		textPuncts.setLayoutData(gdata);
 		
@@ -144,7 +144,7 @@
 		gdata.indent = 10;
 		l4.setLayoutData(gdata);
 		
-		textElisions = toolkit.createText(sectionClient, TokenizerClasses.regElision, SWT.BORDER);
+		textElisions = toolkit.createText(sectionClient, "", SWT.BORDER);
 		gdata = getLongTextGridData();
 		textElisions.setLayoutData(gdata);
 		
@@ -154,7 +154,7 @@
 		gdata.indent = 10;
 		l3.setLayoutData(gdata);
 		
-		textPunctsStrong = toolkit.createText(sectionClient, TokenizerClasses.punct_strong, SWT.BORDER);
+		textPunctsStrong = toolkit.createText(sectionClient, "", SWT.BORDER);
 		gdata = getLongTextGridData();
 		textPunctsStrong.setLayoutData(gdata);
 		
@@ -170,11 +170,11 @@
 			
 			@Override
 			public void widgetSelected(SelectionEvent e) {
-				TokenizerClasses.reset();
-				textWhiteSpaces.setText(TokenizerClasses.whitespaces);
-				textPuncts.setText(TokenizerClasses.regPunct);
-				textPunctsStrong.setText(TokenizerClasses.punct_strong);
-				textElisions.setText(TokenizerClasses.regElision);
+				TokenizerClasses tc = new TokenizerClasses(); // use default tokenizer classes
+				textWhiteSpaces.setText(tc.whitespaces);
+				textPuncts.setText(tc.regPunct);
+				textPunctsStrong.setText(tc.punct_strong);
+				textElisions.setText(tc.regElision);
 			}
 		});
 		
@@ -314,11 +314,13 @@
 		if (this.section.isDisposed()) return;
 		if (project == null) return;
 		
+		TokenizerClasses tc = new TokenizerClasses();
+		tc.loadFromProject(project.getPreferencesScope());
 		
-		textWhiteSpaces.setText(project.getTokenizerParameter("whitespaces", TokenizerClasses.whitespaces)); //$NON-NLS-1$
-		textPuncts.setText(project.getTokenizerParameter("regPunct", TokenizerClasses.regPunct)); //$NON-NLS-1$
-		textPunctsStrong.setText(project.getTokenizerParameter("punct_strong", TokenizerClasses.punct_strong)); //$NON-NLS-1$
-		textElisions.setText(project.getTokenizerParameter("regElision", TokenizerClasses.regElision)); //$NON-NLS-1$
+		textWhiteSpaces.setText(project.getTokenizerParameter("whitespaces", tc.whitespaces)); //$NON-NLS-1$
+		textPuncts.setText(project.getTokenizerParameter("regPunct", tc.regPunct)); //$NON-NLS-1$
+		textPunctsStrong.setText(project.getTokenizerParameter("punct_strong", tc.punct_strong)); //$NON-NLS-1$
+		textElisions.setText(project.getTokenizerParameter("regElision", tc.regElision)); //$NON-NLS-1$
 		
 		String wtagElement = project.getTokenizerWordElement();
 		wordElementText.setText(wtagElement);
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditor.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditor.java	(revision 3060)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditor.java	(revision 3061)
@@ -513,10 +513,9 @@
 		}
 		catch (Throwable e) {
 			Log.severe(TXMCoreMessages.bind("TXMEditor.createPartControl(): can not create the editor for result {0}.", this.getResult())); //$NON-NLS-1$
-			e.printStackTrace();
+			Log.printStackTrace(e);
 			createPartControlDoneSucessfully = false;
 		}
-		
 	}
 	
 	@Override
@@ -1102,6 +1101,9 @@
 			}
 			else if (tmpEditor instanceof TXMMultiPageEditor) {
 				editor = (TXMEditor<? extends TXMResult>) ((TXMMultiPageEditor) tmpEditor).getMainEditorPart();
+				
+				// If result specify a opening Area use it
+				
 			}
 			else {
 				Log.severe(NLS.bind("Failed to open editor {0}.", editorId)); // $NON-NLS-1$
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/QueryWidget.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/QueryWidget.java	(revision 3060)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/QueryWidget.java	(revision 3061)
@@ -47,12 +47,12 @@
  * 
  */
 public class QueryWidget extends Combo {
-
+	
 	SearchEngine se;
 	
 	/** The history. */
-	private static Deque<String> history = new LinkedList<String>();
-
+	private static Deque<String> history = new LinkedList<>();
+	
 	/**
 	 * Instantiates a new query widget.
 	 *
@@ -68,11 +68,16 @@
 	public QueryWidget(Composite composite, int style) {
 		this(composite, style, SearchEnginesManager.getCQPSearchEngine());
 	}
-
+	
 	public void setSearchEngine(SearchEngine se) {
 		this.se = se;
 	}
-
+	
+	
+	public SearchEngine getSearchEngine() {
+		return this.se;
+	}
+	
 	/**
 	 * Gets the CQP query string inferred from the user input.
 	 *
@@ -82,27 +87,30 @@
 		String rawQuery;
 		if (getSelectionIndex() < 0) {
 			rawQuery = getText();
-		} else {
+		}
+		else {
 			rawQuery = this.getItem(this.getSelectionIndex());
 		}
 		return se.newQuery().setQuery(rawQuery).getQueryString();
 	}
-
+	
 	/**
 	 * Memorize.
 	 */
 	public void memorize() {
 		String inputString;
-		if (getSelectionIndex() == -1)
+		if (getSelectionIndex() == -1) {
 			inputString = getText();
-		else
+		}
+		else {
 			inputString = getItems()[getSelectionIndex()];
+		}
 		history.remove(inputString);
 		history.addFirst(inputString);
 		this.setItems(history.toArray(new String[history.size()]));
 		this.setText(this.getItem(0));
 	}
-
+	
 	/**
 	 * Memorize.
 	 *
@@ -116,24 +124,27 @@
 		this.setItems(history.toArray(new String[history.size()]));
 		this.setText(this.getItem(0));
 	}
-
-	/* (non-Javadoc)
+	
+	/*
+	 * (non-Javadoc)
 	 * @see org.eclipse.swt.widgets.Combo#checkSubclass()
 	 */
 	@Override
 	protected void checkSubclass() {
+		
 	}
-
+	
 	/**
 	 * Gets the query.
 	 *
 	 * @return the query
 	 */
 	public IQuery getQuery() {
-		if (!this.getQueryString().isEmpty())	{
-			return se.newQuery().setQuery(this.getQueryString());	
-		} else {
+		if (!this.getQueryString().isEmpty()) {
+			return se.newQuery().setQuery(this.getQueryString());
+		}
+		else {
 			return null;
 		}
-	};
+	}
 }
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/NewNavigationWidget.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/NewNavigationWidget.java	(revision 3060)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/NewNavigationWidget.java	(revision 3061)
@@ -50,28 +50,30 @@
  * @author sjacquot
  */
 public class NewNavigationWidget extends Composite {
-
+	
 	/** The info line. */
 	Label infoLine;
+	
 	Text currentPositionText;
-
+	
 	/** The first. */
 	Button first;
-
+	
 	/** The last. */
 	Button last;
-
+	
 	/** The next. */
 	Button next;
-
+	
 	/** The prev. */
 	Button prev;
-
+	
 	/** The n line per page. */
 	int nLinePerPage;
+	
 	private Color whiteColor;
-
 	
+	
 	/**
 	 * Current position;
 	 */
@@ -106,11 +108,11 @@
 		this.currentPosition = 0;
 		
 		this.setLayout(new GridLayout(6, false));
-
+		
 		// | [|<] [<] [info] [>] [>|] |
-
+		
 		// [|<]
-		first = new Button(this, SWT.PUSH);
+		first = new Button(this, SWT.FLAT | SWT.PUSH);
 		first.setToolTipText("|<"); //$NON-NLS-1$
 		first.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, false));
 		first.addSelectionListener(new SelectionListener() {
@@ -127,9 +129,9 @@
 				
 			}
 		});
-
+		
 		// [<]
-		prev = new Button(this, SWT.PUSH);
+		prev = new Button(this, SWT.FLAT | SWT.PUSH);
 		prev.setToolTipText("<"); //$NON-NLS-1$
 		prev.addSelectionListener(new SelectionListener() {
 			
@@ -145,8 +147,8 @@
 				
 			}
 		});
-
 		
+		
 		// [current]
 		currentPositionText = new Text(this, SWT.BORDER);
 		GridData currentPositionLayoutData = new GridData(GridData.VERTICAL_ALIGN_CENTER, SWT.CENTER, true, false);
@@ -169,18 +171,18 @@
 				}
 			}
 		});
-
-
+		
+		
 		// [info]
 		infoLine = new Label(this, SWT.NONE);
 		GridData layoutData = new GridData(GridData.VERTICAL_ALIGN_CENTER, SWT.CENTER, true, false);
 		infoLine.setLayoutData(layoutData);
-
+		
 		whiteColor = currentPositionText.getBackground();
 		currentPositionText.setBackground(infoLine.getBackground());
 		
 		// [>]
-		next = new Button(this, SWT.PUSH);
+		next = new Button(this, SWT.FLAT | SWT.PUSH);
 		next.setToolTipText(">"); //$NON-NLS-1$
 		next.addSelectionListener(new SelectionListener() {
 			
@@ -196,10 +198,10 @@
 				
 			}
 		});
-
-
+		
+		
 		// [>|]
-		last = new Button(this, SWT.PUSH);
+		last = new Button(this, SWT.FLAT | SWT.PUSH);
 		last.setToolTipText(">|"); //$NON-NLS-1$
 		last.addSelectionListener(new SelectionListener() {
 			
@@ -215,14 +217,14 @@
 				
 			}
 		});
-
-		first.setImage(IImageKeys.getImage(IImageKeys.CTRLSTART)); 
+		
+		first.setImage(IImageKeys.getImage(IImageKeys.CTRLSTART));
 		prev.setImage(IImageKeys.getImage(IImageKeys.CTRLREVERSE));
 		next.setImage(IImageKeys.getImage(IImageKeys.CTRLPLAY));
 		last.setImage(IImageKeys.getImage(IImageKeys.CTRLEND));
 		
 	}
-
+	
 	/**
 	 * 
 	 * @param parent
@@ -231,14 +233,14 @@
 		this(parent, SWT.NONE);
 	}
 	
-
+	
 	public void addGoToKeyListener(KeyListener keyListener) {
 		currentPositionText.addKeyListener(keyListener);
 		currentPositionText.setEditable(true);
-		//currentPositionText.setBackground(whiteColor);
-		//currentPosition.setBackground(new Color(currentPosition.get));
+		// currentPositionText.setBackground(whiteColor);
+		// currentPosition.setBackground(new Color(currentPosition.get));
 	}
-
+	
 	/**
 	 * Adds the first listener.
 	 *
@@ -247,7 +249,7 @@
 	public void addFirstListener(SelectionListener selectionListener) {
 		first.addSelectionListener(selectionListener);
 	}
-
+	
 	/**
 	 * Adds the next listener.
 	 *
@@ -256,7 +258,7 @@
 	public void addNextListener(SelectionListener selectionListener) {
 		next.addSelectionListener(selectionListener);
 	}
-
+	
 	/**
 	 * Adds the previous listener.
 	 *
@@ -265,7 +267,7 @@
 	public void addPreviousListener(SelectionListener selectionListener) {
 		prev.addSelectionListener(selectionListener);
 	}
-
+	
 	/**
 	 * Adds the last listener.
 	 *
@@ -274,7 +276,7 @@
 	public void addLastListener(SelectionListener selectionListener) {
 		last.addSelectionListener(selectionListener);
 	}
-
+	
 	/**
 	 * Sets the first enabled.
 	 *
@@ -283,7 +285,7 @@
 	public void setFirstEnabled(boolean b) {
 		first.setEnabled(b);
 	}
-
+	
 	/**
 	 * Sets the last enabled.
 	 *
@@ -292,7 +294,7 @@
 	public void setLastEnabled(boolean b) {
 		last.setEnabled(b);
 	}
-
+	
 	/**
 	 * Sets the next enabled.
 	 *
@@ -301,7 +303,7 @@
 	public void setNextEnabled(boolean b) {
 		next.setEnabled(b);
 	}
-
+	
 	/**
 	 * Sets the previous enabled.
 	 *
@@ -310,46 +312,47 @@
 	public void setPreviousEnabled(boolean b) {
 		prev.setEnabled(b);
 	}
-
 	
 	
+	
 	protected int getCurrentPositionFromTextField() {
 		int ret = -1;
 		try {
 			ret = Integer.parseInt(this.currentPositionText.getText());
-		} catch(Exception e) {
+		}
+		catch (Exception e) {
 			System.out.println(TXMUIMessages.errorWhileGettingCurrentPositionValueColon);
 			Log.printStackTrace(e);
 		}
 		return ret;
 	}
-
 	
-
+	
+	
 	/**
 	 * @return the minPosition
 	 */
 	public int getMinPosition() {
 		return minPosition;
 	}
-
-
+	
+	
 	/**
 	 * @param minPosition the minPosition to set
 	 */
 	public void setMinPosition(int minPosition) {
 		this.minPosition = minPosition;
 	}
-
-
+	
+	
 	/**
 	 * @return the maxPosition
 	 */
 	public int getMaxPosition() {
 		return maxPosition;
 	}
-
-
+	
+	
 	/**
 	 * @param maxPosition the maxPosition to set
 	 */
@@ -360,26 +363,29 @@
 	/**
 	 * Refreshes the widgets.
 	 */
-	public void refresh()	{
+	public void refresh() {
 		
 		// range tests
-		if(this.currentPosition < this.minPosition)	{
+		if (this.currentPosition < this.minPosition) {
 			this.currentPosition = this.minPosition;
 		}
-		else if(this.currentPosition > this.maxPosition)	{
+		else if (this.currentPosition > this.maxPosition) {
 			this.currentPosition = this.maxPosition;
 		}
 		
 		// update UI
 		this.currentPositionText.setText(String.valueOf(this.currentPosition));
+		
 		this.prev.setEnabled(this.currentPosition > this.minPosition);
 		this.next.setEnabled(this.currentPosition < this.maxPosition);
 		this.first.setEnabled(this.currentPosition > this.minPosition);
 		this.last.setEnabled(this.currentPosition < this.maxPosition);
+		
+		setInfoLineText(" / " + (this.maxPosition - this.minPosition)); //$NON-NLS-1$
 		this.layout();
 	}
-
-
+	
+	
 	/**
 	 * Sets the info line text.
 	 *
@@ -387,7 +393,7 @@
 	 */
 	public void setInfoLineText(String s) {
 		this.infoLine.setText(s);
-	} 
+	}
 	
 	
 	/**
@@ -396,16 +402,16 @@
 	public void setCurrentPosition(int currentPosition) {
 		this.currentPosition = currentPosition + this.shift;
 	}
-
-
+	
+	
 	/**
 	 * @return the currentPosition
 	 */
 	public int getCurrentPosition() {
 		return this.currentPosition - this.shift;
 	}
-
-
+	
+	
 	/**
 	 * @return the currentPositionText
 	 */
@@ -413,4 +419,4 @@
 		return currentPositionText;
 	}
 	
-}
\ No newline at end of file
+}
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/ParametersDialog.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/ParametersDialog.java	(revision 3060)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/ParametersDialog.java	(revision 3061)
@@ -560,54 +560,68 @@
 				script.getBinding().setVariable("args", args);
 			}
 		}
-		
+		Log.finest("Calling syncExec on display: " + Display.getDefault());
 		Display.getDefault().syncExec(new Runnable() {
 			
 			@Override
 			public void run() {
-				boolean okNames = true;
-				CmdLineParser parser = new CmdLineParser(bean);
-				
-				Display display = Display.getCurrent();
-				Shell shell = display.getActiveShell();
-				
-				// check names
-				Class c = bean.getClass();
-				for (OptionHandler opt : parser.getOptions()) {
-					try {
-						if (opt.option instanceof NamedOptionDef) {
-							NamedOptionDef option = (NamedOptionDef) opt.option;
-							c.getDeclaredField(option.name());
+				try {
+					boolean okNames = true;
+					CmdLineParser parser = new CmdLineParser(bean);
+					
+					Display display = Display.getCurrent();
+					Shell shell = display.getActiveShell();
+					Log.finest("Display=" + display + " Shell=" + shell);
+					// check names
+					Class c = bean.getClass();
+					Log.finest("Parsing options: " + parser.getOptions());
+					for (OptionHandler opt : parser.getOptions()) {
+						try {
+							if (opt.option instanceof NamedOptionDef) {
+								NamedOptionDef option = (NamedOptionDef) opt.option;
+								c.getDeclaredField(option.name());
+							}
 						}
+						catch (NoSuchFieldException e) {
+							Log.warning(TXMUIMessages.errorInAtOptionNameDeclarationColon + e.getMessage());
+							okNames = false;
+						}
 					}
-					catch (NoSuchFieldException e) {
-						System.out.println(TXMUIMessages.errorInAtOptionNameDeclarationColon + e.getMessage());
-						okNames = false;
-					}
-				}
-				if (okNames) {
-					ParametersDialog dialog = new ParametersDialog(shell, bean, parser.getOptions(), args);
-					if (dialog.getShell() != null)
-						dialog.getShell().setActive();
-					if (dialog.getMustShowDialog()) {
-						retOpen = dialog.open() == ParametersDialog.OK;
-						errorOpen = dialog.isError();
-					}
-					else { // fields initialized by 'args'
-						dialog.initializeMacroVariables(); // with args
-						if (dialog.getNumberOfFields() > 0) dialog.saveParameters();
-						retOpen = true;
-						errorOpen = false;
-					}
-					
-					if (bean instanceof groovy.lang.Script) { // reset the timer binding if already existing
-						groovy.lang.Script script = (groovy.lang.Script) bean;
-						if (script.getBinding().hasVariable("timer")) {
-							Timer timer = (Timer) script.getBinding().getVariable("timer");
-							timer.reset();
+					if (okNames) {
+						ParametersDialog dialog = new ParametersDialog(shell, bean, parser.getOptions(), args);
+						if (dialog.getShell() != null) {
+							Log.finest("Activating shell:" + shell);
+							shell.setActive();
 						}
+						if (dialog.getMustShowDialog()) {
+							Log.finest("The parameters dialog must be opened to fill all mandatory fields.");
+							retOpen = dialog.open() == ParametersDialog.OK;
+							errorOpen = dialog.isError();
+						}
+						else { // fields initialized by 'args'
+							Log.finest("The parameters dialog dont need to be opened all mandatory fields are set: " + args);
+							dialog.initializeMacroVariables(); // with args
+							if (dialog.getNumberOfFields() > 0) dialog.saveParameters();
+							retOpen = true;
+							errorOpen = false;
+						}
+						
+						if (bean instanceof groovy.lang.Script) { // reset the timer binding if already existing
+							
+							groovy.lang.Script script = (groovy.lang.Script) bean;
+							if (script.getBinding().hasVariable("timer")) {
+								Log.finest("Reset groovy execution timer: " + args);
+								Timer timer = (Timer) script.getBinding().getVariable("timer");
+								timer.reset();
+							}
+						}
 					}
 				}
+				catch (Throwable e) {
+					Log.severe("Could not open dialog: " + e);
+					Log.printStackTrace(e);
+					errorOpen = true;
+				}
 			}
 		});
 		return retOpen && !errorOpen;
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/AssistedChoiceQueryWidget.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/AssistedChoiceQueryWidget.java	(revision 3060)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/AssistedChoiceQueryWidget.java	(revision 3061)
@@ -27,6 +27,8 @@
 //
 package org.txm.rcp.swt.widget;
 
+import java.util.ArrayList;
+import java.util.Arrays;
 import java.util.List;
 
 import org.eclipse.jface.viewers.ComboViewer;
@@ -44,35 +46,46 @@
 import org.eclipse.swt.widgets.Button;
 import org.eclipse.swt.widgets.Combo;
 import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Label;
 import org.txm.rcp.IImageKeys;
 import org.txm.rcp.messages.TXMUIMessages;
 import org.txm.rcp.swt.GLComposite;
+import org.txm.rcp.swt.dialog.ComboDialog;
 import org.txm.rcp.swt.dialog.QueryAssistDialog;
 import org.txm.rcp.swt.provider.ListContentProvider;
 import org.txm.searchengine.core.IQuery;
 import org.txm.searchengine.core.SearchEngine;
+import org.txm.searchengine.core.SearchEnginePreferences;
 import org.txm.searchengine.core.SearchEnginesManager;
 import org.txm.searchengine.cqp.corpus.CQPCorpus;
 
 /**
- * The QueryWidget 
- * 	+ the button to open the QueryAssisDialog
- *  + Engine selector 
+ * The QueryWidget
+ * + the button to open the QueryAssisDialog
+ * + Engine selector
  * 
  * @author mdecorde.
  */
 public class AssistedChoiceQueryWidget extends Composite {
-
+	
 	/** The magicstick button: opens the QueryAssist dialog. */
 	protected Button magicstick;
-
+	
 	/** The querywidget. */
 	protected QueryWidget querywidget;
-
+	
 	protected QueryAssistDialog d;
-
-	protected ComboViewer engineCombo;
+	
+	// protected ComboViewer engineCombo;
+	
 	protected List<SearchEngine> engines;
+	
+	private GridData magcistickGData;
+	
+	private Button settingsButton;
+	
+	private Label selectedEngineLabel;
+	
 	/**
 	 * Instantiates a new assisted query widget.
 	 *
@@ -82,49 +95,79 @@
 	 */
 	public AssistedChoiceQueryWidget(Composite parent, int style, final CQPCorpus corpus) {
 		super(parent, SWT.NONE);
-		this.setLayout(GLComposite.createDefaultLayout(3));
-
+		this.setLayout(GLComposite.createDefaultLayout(5));
+		
 		engines = SearchEnginesManager.getAvailableEngines(corpus.getMainCorpus());
-
+		SearchEngine initialEngine = null;
 		if (engines.size() > 1) {
-			engineCombo = new ComboViewer(this);
-			Combo ccombo = engineCombo.getCombo();
-			engineCombo.setContentProvider(new ListContentProvider());
-			ccombo.setLayoutData(new GridData(GridData.FILL, GridData.CENTER,
-					false, false));
-			engineCombo.setLabelProvider(new LabelProvider() {
+			
+			// set default engine
+			String defaultEngineName = SearchEnginePreferences.getInstance().getString(SearchEnginePreferences.DEFAULT_SEARCH_ENGINE);
+			int iDefault = -1;
+			int iSuperDefault = 0;
+			for (int i = 0; i < engines.size(); i++) {
+				SearchEngine engine = engines.get(i);
+				if (defaultEngineName.equals(engine.getName())) {
+					iDefault = i;
+				}
+				if ("CQP".equals(engine.getName())) {
+					iSuperDefault = i;
+				}
+			}
+			
+			if (iDefault >= 0) {
+				initialEngine = engines.get(iDefault);
+			}
+			else {
+				initialEngine = engines.get(iSuperDefault);
+			}
+		}
+		else {
+			initialEngine = engines.get(0);
+		}
+		
+		selectedEngineLabel = new Label(this, SWT.NONE);
+		selectedEngineLabel.setText("");
+		GridData gdata = new GridData(GridData.FILL, GridData.CENTER, false, false);
+		selectedEngineLabel.setLayoutData(gdata);
+		
+		if (SearchEnginePreferences.getInstance().getBoolean(SearchEnginePreferences.SHOW_SEARCH_ENGINES)) {
+			settingsButton = new Button(this, SWT.PUSH);
+			settingsButton.setLayoutData(new GridData(GridData.FILL, GridData.CENTER, false, false));
+			settingsButton.setImage(IImageKeys.getImage(IImageKeys.ACTION_SEARCH_SETTINGS));
+			settingsButton.setToolTipText(TXMUIMessages.openTheQueryAssistant);
+			settingsButton.addSelectionListener(new SelectionListener() {
+				
 				@Override
-				public String getText(Object element) {
-					return ((SearchEngine)element).getName();
+				public void widgetSelected(SelectionEvent e) {
+					ArrayList<String> values = new ArrayList<>();
+					for (SearchEngine se : engines) {
+						values.add(se.getName());
+					}
+					ComboDialog dialog = new ComboDialog(e.display.getActiveShell(), "Engines", values, querywidget.getSearchEngine().getName());
+					if (dialog.open() == ComboDialog.OK) {
+						String name = dialog.getSelectedValue();
+						for (SearchEngine se : engines) {
+							if (se.getName().equals(name)) {
+								changeEngine(se);
+								return;
+							}
+						}
+					}
 				}
-			});
-			engineCombo.setInput(engines);
-			ccombo.select(0);
-			engineCombo.addSelectionChangedListener(new ISelectionChangedListener() {
-
+				
 				@Override
-				public void selectionChanged(SelectionChangedEvent event) {
-					ISelection isel = event.getSelection();
-					StructuredSelection sel = (StructuredSelection)isel;
-					Object o = sel.getFirstElement();
-					SearchEngine se = (SearchEngine)o;
-					querywidget.setSearchEngine(se);
-					
-					GridData gdata = (GridData) querywidget.getLayoutData();
-					gdata.heightHint = -1;
-					querywidget.layout();
-					relayout();
-					
-				}
+				public void widgetDefaultSelected(SelectionEvent e) {}
 			});
 		}
-
+		
 		magicstick = new Button(this, SWT.PUSH);
-		magicstick.setLayoutData(new GridData(GridData.FILL, GridData.CENTER,
-				false, false));
+		magcistickGData = new GridData(GridData.FILL, GridData.CENTER, false, false);
+		magicstick.setLayoutData(magcistickGData);
 		magicstick.setImage(IImageKeys.getImage(IImageKeys.ACTION_ASSISTQUERY));
 		magicstick.setToolTipText(TXMUIMessages.openTheQueryAssistant);
 		magicstick.addSelectionListener(new SelectionListener() {
+			
 			@Override
 			public void widgetSelected(SelectionEvent e) {
 				d = new QueryAssistDialog(e.display.getActiveShell(), corpus);
@@ -132,70 +175,101 @@
 					querywidget.setText(d.getQuery());
 				}
 			}
-
+			
 			@Override
-			public void widgetDefaultSelected(SelectionEvent e) { }
+			public void widgetDefaultSelected(SelectionEvent e) {}
 		});
-
-		for (SearchEngine engine : engines) {
-			querywidget = new QueryWidget(this, style, engine);
-			querywidget.setLayoutData(new GridData(GridData.FILL, GridData.CENTER, true, false));
-			break; // set the first engine as default engine
+		
+		setMagicEnabled("CQP".equals(initialEngine.getName()));
+		
+		querywidget = new QueryWidget(this, style, initialEngine);
+		querywidget.setLayoutData(new GridData(GridData.FILL, GridData.CENTER, true, false));
+	}
+	
+	protected void changeEngine(SearchEngine se) {
+		querywidget.setSearchEngine(se);
+		
+		// GridData gdata = (GridData) querywidget.getLayoutData();
+		// gdata.heightHint = -1;
+		// querywidget.layout();
+		// relayout();
+		
+		setMagicEnabled("CQP".equals(se.getName()));
+		
+		String defaultEngineName = SearchEnginePreferences.getInstance().getString(SearchEnginePreferences.DEFAULT_SEARCH_ENGINE);
+		if (defaultEngineName.equals(se.getName())) {
+			selectedEngineLabel.setText("");
 		}
+		else {
+			selectedEngineLabel.setText(" " + se.getName() + " ");
+		}
+		selectedEngineLabel.getParent().layout();
 	}
 	
+	private void setMagicEnabled(boolean b) {
+		magicstick.setEnabled(b);
+		
+		if (b) {
+			magcistickGData.widthHint = magcistickGData.minimumWidth = SWT.DEFAULT;
+		}
+		else {
+			magcistickGData.widthHint = magcistickGData.minimumWidth = 0;
+		}
+		magicstick.getParent().layout();
+	}
+	
 	protected void relayout() {
 		Composite parent = AssistedChoiceQueryWidget.this.getParent();
-//		parent.layout(true);
-//		parent.getParent().layout(true);
+		// parent.layout(true);
+		// parent.getParent().layout(true);
 		try {
 			parent.getParent().getParent().layout(true);
-		} catch(Exception e) {
+		}
+		catch (Exception e) {
 			parent.layout(true);
 		}
-//		while (parent instanceof Composite) {
-//			
-//			if (!(parent.getParent() instanceof Composite)) {
-//				parent.layout();
-//				return;
-//			}
-//			parent = parent.getParent();
-//		}
+		// while (parent instanceof Composite) {
+		//
+		// if (!(parent.getParent() instanceof Composite)) {
+		// parent.layout();
+		// return;
+		// }
+		// parent = parent.getParent();
+		// }
 	}
-
+	
+	@Override
 	public void setEnabled(boolean b) {
 		super.setEnabled(b);
 		querywidget.setEnabled(b);
 	}
-
+	
 	public void setSearchEngine(SearchEngine engine) {
-		if (engineCombo != null) {
-			int i = engines.indexOf(engine);
-			if (i >= 0) {
-				engineCombo.setSelection(new StructuredSelection(engine));
-			}
+		int i = engines.indexOf(engine);
+		if (i >= 0) {
+			changeEngine(engine);
 		}
 	}
-
+	
 	public void setSearchEngine(String name) {
-		if (engineCombo != null) {
-			for (int i = 0 ; i < engines.size() ; i++) {
-				if (name.equals(engines.get(i).getName())) {
-					engineCombo.setSelection(new StructuredSelection(engines.get(i)));
-				}
+		for (int i = 0; i < engines.size(); i++) {
+			if (name.equals(engines.get(i).getName())) {
+				changeEngine(engines.get(i));
 			}
 		}
 	}
-
+	
 	public QueryWidget getQueryWidget() {
 		return querywidget;
 	}
-
+	
+	@Override
 	public boolean setFocus() {
 		return this.querywidget.setFocus();
 	}
-
-	/* (non-Javadoc)
+	
+	/*
+	 * (non-Javadoc)
 	 * @see org.eclipse.swt.widgets.Control#addKeyListener(org.eclipse.swt.events.KeyListener)
 	 */
 	@Override
@@ -203,7 +277,7 @@
 		if (querywidget != null)
 			this.querywidget.addKeyListener(listener);
 	}
-
+	
 	/**
 	 * Gets the query string.
 	 *
@@ -212,7 +286,7 @@
 	public String getQueryString() {
 		return querywidget.getQueryString();
 	}
-
+	
 	/**
 	 * Gets the query string.
 	 *
@@ -221,14 +295,14 @@
 	public String getRawString() {
 		return querywidget.getText();
 	}
-
+	
 	/**
 	 * Memorize.
 	 */
 	public void memorize() {
 		querywidget.memorize();
 	}
-
+	
 	/**
 	 * Memorize.
 	 *
@@ -237,32 +311,32 @@
 	public void memorize(String query) {
 		querywidget.memorize(query);
 	}
-
+	
 	/**
 	 * Clears the query test.
 	 */
-	public void clearQuery()	{
+	public void clearQuery() {
 		this.querywidget.setText(""); //$NON-NLS-1$
 	}
-
+	
 	/**
 	 * Sets the text.
 	 *
 	 * @param query the new text
 	 */
 	public void setText(String query) {
-
-		//		if(query.isEmpty())	{
-		//			query = ""; //$NON-NLS-1$
-		//		}
-
+		
+		// if(query.isEmpty()) {
+		// query = ""; //$NON-NLS-1$
+		// }
+		
 		// fix the query
-		//query = query.replaceAll("^\"(.*)\"$","$1"); //$NON-NLS-1$ -> don't work for the '"A" "B"' queries 
-
+		// query = query.replaceAll("^\"(.*)\"$","$1"); //$NON-NLS-1$ -> don't work for the '"A" "B"' queries
+		
 		querywidget.setText(query);
 	}
-
+	
 	public IQuery getQuery() {
 		return this.querywidget.getQuery();
 	}
-}
\ No newline at end of file
+}
